"""
this file contains the Lexer that is used in parsing Grammar specifications
"""

from PyLR import Lexer
import re

class GrammarLex(Lexer.Lexer):
    
    ID = re.compile(r"[a-zA-Z_][a-zA-Z_0-9]*")
    COLON = re.compile(r":")
    SCOLON = re.compile(r";")
    NL = re.compile(r"\n")
    WS = re.compile(r"\s+")
    OR = re.compile(r"\|")
    LPAREN = re.compile(r"\(")
    RPAREN = re.compile(r"\)")
    GDEL = re.compile(r'"""')
    LEX = re.compile(r"_lex\s+([^\n]*)")
    CODE = re.compile(r"_code\s+([^\n]*)")
    CLASS = re.compile(r"_class\s+([a-zA-Z_][a-zA-Z_0-9]*)")
    COMMENT = re.compile(r"^\s*#[^\n]*")
    
    def __init__(self):
	Lexer.Lexer.__init__(self)
	self.addmatch(self.LEX, "LEX", self.returngroup1)
	self.addmatch(self.CODE, "CODE", self.returngroup1)
	self.addmatch(self.CLASS, "CLASS", self.returngroup1)
	prgtoks =  [(self.ID, "ID"), 
		    (self.COLON, "COLON"),
		    (self.SCOLON, "SCOLON"),
		    (self.OR, "OR"),
		    (self.LPAREN, "LPAREN"),
		    (self.RPAREN, "RPAREN"),
		    (self.GDEL, "GDEL")]
	for (prg, tok) in prgtoks:
	    self.addmatch(prg, tok)
	self.addmatch(self.COMMENT, "", None, Lexer.SKIPTOK)
	self.addmatch(self.WS, "", None, Lexer.SKIPTOK)	
	self.seteof()

    def returngroup1(self, mo):
	return mo.group(1)


